//////////////
//Datablocks//
//////////////
BrickSpawnPointData.LifeRP_AdminOnly = true;
brickCheckpointData.LifeRP_AdminOnly = true;

///////////
//Package//
///////////
if(isPackage(GameModeLifeRPBrickPackage))
	deactivatePackage(GameModeLifeRPBrickPackage);
package GameModeLifeRPBrickPackage
{
	function ServerCmdPlantBrick(%client)
	{
		//simple checks
		%player = %client.player;
		if(!isObject(%player))
		{
			parent::ServerCmdPlantBrick(%client);
			return;
		}
		
		%tempBrick = %player.tempBrick;
		if(!isObject(%tempBrick))
		{
			parent::ServerCmdPlantBrick(%client);
			return;
		}
		
		%tempBrickData = %tempBrick.getDatablock();
		
		//admin only check
		if(%tempBrickData.LifeRP_AdminOnly == true)
		{
			if(!%client.isAdmin)
			{
				commandToClient(%client, 'MessageBoxOK', "Admin Only Brick", "This brick can only be placed by server administration.<br>Sorry about that!");
				return;
			}
			else
				%client.centerPrint("\c6Placing admin only brick...", 1);
		}
		
		%pos = %tempBrick.getPosition();
		%posZ = getWord(%pos, 2);
		%bottom = %posZ - (%tempBrickData.bricksizez * 0.1);
		
		//on ground check
		if(mfloor(%bottom * 10) < -1 || mfloor(%bottom * 10) > 1 )
		{
			parent::ServerCmdPlantBrick(%client);
			return;
		}
		
		%tempBrickID = %tempBrickData.getID();
		
		//baseplate check
		if((%tempBrickID != Brick16x16fData.getID()) && (%tempBrickID != Brick16x32fData.getID()) && (%tempBrickID != Brick32x32fData.getID()) && (%tempBrickID != Brick48x48fData.getID()) && (%tempBrickID != Brick64x64fData.getID()))
		{
			commandToClient(%client, 'MessageBoxOK', "Invalid Brick", "You must start with a Plain Baseplate.<br><bitmap:base/client/ui/brickIcons/32x32 Base>");
			return;
		}
		
		//it passed all the checks
		
		//prices
		if(%tempBrickID == Brick16x16fData.getID())
			%price = $LifeRP::Pref::Price16x16;
		if(%tempBrickID == Brick16x32fData.getID())
			%price = $LifeRP::Pref::Price16x32;
		if(%tempBrickID == Brick32x32fData.getID())
			%price = $LifeRP::Pref::Price32x32;
		if(%tempBrickID == Brick48x48fData.getID())
			%price = $LifeRP::Pref::Price48x48;
		if(%tempBrickID == Brick64x64fData.getID())
			%price = $LifeRP::Pref::Price64x64;
		
		if($LifeRP_Player[%client.bl_id, "Score"] >= %price)
		{
			%precount = %client.brickGroup.getCount();
			parent::ServerCmdPlantBrick(%client);
			%postcount = %client.brickGroup.getCount();
			
			//only charge them if the baseplate was placed correctly
			if(%precount < %postcount) //this is to prevent having them lose money if they overlap it with another baseplate by accident
			{
				%client.LifeRP_AddScore((%price * -1), "Placing grounded baseplate");
				CommandToClient(%client, 'MessageBoxOK', "Hey there, it looks like you're trying to build!", "Please remember to practice good building etiquette. Always align the corners of your grounded baseplate with other baseplates. Follow the grid. This keeps the build organized and gives builders more room. <br><br>Give us less headaches please!");
			}
		}
		else
			commandToClient(%client, 'MessageBoxOK', "Insufficient Funds", "You cannot afford to place a grounded baseplate of this size.<br>The size you attempted to place costs $" @ %price @ ".");
	}
	
	function fxDTSBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);

		%brickData = %brick.getDatablock();
		%brickID = %brickData.getID();
		
		//add brick to list of spawns
		if(%brickID == BrickSpawnPointData.getID())
			$LifeRP::Spawns = $LifeRP::Spawns SPC %brick;
		
		//add brick to list of prison spawns
		if(%brickID == BrickLifeRPPrisonSpawnData.getID())
			$LifeRP::PrisonSpawns = $LifeRP::PrisonSpawns SPC %brick;
	}

	function fxDTSBrick::onLoadPlant(%brick)
	{
		Parent::onLoadPlant(%brick);
	
		%brickData = %brick.getDatablock();
		%brickID = %brickData.getID();
		
		//add brick to list of spawns
		if(%brickID == BrickSpawnPointData.getID())
			$LifeRP::Spawns = $LifeRP::Spawns SPC %brick;
		
		//add brick to list of prison spawns
		if(%brickID == BrickLifeRPPrisonSpawnData.getID())
			$LifeRP::PrisonSpawns = $LifeRP::PrisonSpawns SPC %brick;
	}
	
	function fxDTSBrick::onDeath(%brick)
	{
		//spawn removal
		for(%a = 0; %a < getWordCount($LifeRP::Spawns); %a++)
		{
			%spawnBrick = getWord($LifeRP::Spawns, %a);
			
			if(isObject(%spawnBrick))
			{
				//remove brick from list of spawns
				if(%spawnBrick == %brick)
					$LifeRP::Spawns = strreplace($LifeRP::Spawns, %brick, "");
			}
		}
		
		for(%a = 0; %a < getWordCount($LifeRP::PrisonSpawns); %a++)
		{
			%prisonBrick = getWord($LifeRP::PrisonSpawns, %a);
			
			if(isObject(%prisonBrick))
			{
				//remove brick from list of prison spawns
				if(%prisonBrick == %brick)
					$LifeRP::PrisonSpawns = strreplace($LifeRP::PrisonSpawns, %brick, "");
			}
		}
		
		//simple checks
		%client = getBrickGroupFromObject(%brick).client;
		if(!isObject(%client))
		{
			parent::onDeath(%brick);
			return;
		}
		
		%tempBrick = %client.player.tempBrick;
		if(%brick == %tempBrick)
		{
			parent::onDeath(%brick);
			return;
		}
		
		%brickData = %brick.getDatablock();
		%brickID = %brickData.getID();
		
		//baseplate check
		if((%brickID != Brick16x16fData.getID()) && (%brickID != Brick16x32fData.getID()) && (%brickID != Brick32x32fData.getID()) && (%brickID != Brick48x48fData.getID()) && (%brickID != Brick64x64fData.getID()))
		{
			parent::onDeath(%brick);
			return;
		}
		
		%pos = %brick.getPosition();
		%posZ = getWord(%pos, 2);
		%bottom = %posZ - (%brickData.bricksizez * 0.1);
		
		//on ground check
		if(mfloor(%bottom * 10) < -1 || mfloor(%bottom * 10) > 1 )
		{
			parent::onDeath(%brick);
			return;
		}
		
		//it passed all the checks
		
		if($LifeRP::Pref::BaseplateReturnMultiplier > 1)
			$LifeRP::Pref::BaseplateReturnMultiplier = "1.0";
		
		if($LifeRP::Pref::BaseplateReturnMultiplier < -1)
			$LifeRP::Pref::BaseplateReturnMultiplier = "-1.0";
		
		//prices
		if(%brickID == Brick16x16fData.getID())
			%price = mfloor($LifeRP::Pref::Price16x16 * $LifeRP::Pref::BaseplateReturnMultiplier);
		if(%brickID == Brick16x32fData.getID())
			%price = mfloor($LifeRP::Pref::Price16x32 * $LifeRP::Pref::BaseplateReturnMultiplier);
		if(%brickID == Brick32x32fData.getID())
			%price = mfloor($LifeRP::Pref::Price32x32 * $LifeRP::Pref::BaseplateReturnMultiplier);
		if(%brickID == Brick48x48fData.getID())
			%price = mfloor($LifeRP::Pref::Price48x48 * $LifeRP::Pref::BaseplateReturnMultiplier);
		if(%brickID == Brick64x64fData.getID())
			%price = mfloor($LifeRP::Pref::Price64x64 * $LifeRP::Pref::BaseplateReturnMultiplier);
		
		//give them money back for having it destroyed
		%client.LifeRP_AddScore(%price, "Grounded baseplate destroyed");
		parent::onDeath(%brick);
	}
	
	function fxDTSBrick::onRemove(%this)
	{
		//spawm removal
		for(%a = 0; %a < getWordCount($LifeRP::Spawns); %a++)
		{
			%spawnBrick = getWord($LifeRP::Spawns, %a);
			
			if(isObject(%spawnBrick))
			{
				//remove brick from list of spawns
				if(%spawnBrick == %brick)
					$LifeRP::Spawns = strreplace($LifeRP::Spawns, %brick, "");
			}
		}
		
		for(%a = 0; %a < getWordCount($LifeRP::PrisonSpawns); %a++)
		{
			%prisonBrick = getWord($LifeRP::PrisonSpawns, %a);
			
			if(isObject(%prisonBrick))
			{
				//remove brick from list of prison spawns
				if(%prisonBrick == %brick)
					$LifeRP::PrisonSpawns = strreplace($LifeRP::PrisonSpawns, %brick, "");
			}
		}
		
		parent::onRemove(%this);
	}
};
activatePackage(GameModeLifeRPBrickPackage);