/////////////////
//Scriptobjects//
/////////////////

function LifeRP_addAllJobs()
{
	LifeRP_addJobFromFile("slacker");
	LifeRP_addJobFromFile("writer");
	LifeRP_addJobFromFile("trash");
}

function LifeRP_addJobFromFile(%file)
{
	if(isFile("Add-Ons/GameMode_LifeRP/jobs/" @ %file @ ".cs"))
	{
		exec("Add-Ons/GameMode_LifeRP/jobs/" @ %file @ ".cs");
		
		if($LifeRP::temp::job::id $= "")
		{
			echo("ERROR: No ID found for" @ %file @ ".cs.");
			deleteVariables("$LifeRP::temp::job::*");
			return;
		}
		
		if(isObject($LifeRP_job[$LifeRP::temp::job::id]))
		{
			echo("ERROR: $LifeRP_job" @ $LifeRP::temp::job::id @ " already exists.");
			deleteVariables("$LifeRP::temp::job::*");
			return;
		}
		
		$LifeRP_job[$LifeRP::temp::job::id] = new scriptObject()
		{
			id					= $LifeRP::temp::job::id; //can be anything, just make sure there are no spaces. example: "taxidriver"
			name				= $LifeRP::temp::job::name; //job name example: "Taxi Driver"
			
			description1		= $LifeRP::temp::job::description1; //description.
			description2		= $LifeRP::temp::job::description2; //second line if needed.
			
			quotaMessage		= $LifeRP::temp::job::quotaMessage; //message that shows up that tells the player how much of the quota they've done.
			quota				= $LifeRP::temp::job::quota; //quota needed per hour to be paid.
			quotaExtra			= $LifeRP::temp::job::quotaExtra; //quota needed to be paid extra. make it less than normal quota to disable.
			
			repBonus			= $LifeRP::temp::job::repBonus; //rep earned upon having quotaExtra
			repLevel			= $LifeRP::temp::job::repLevel; //rep required per promotion level
			
			paycheck			= $LifeRP::temp::job::paycheck; //base paychecks. if quota is 0 or less paychecks are given to the player even if they do nothing.
			paycheckExtra		= $LifeRP::temp::job::paycheckExtra; //if quotaExtra is more than 0 paychecks may be extra if they do extra.
			paycheckStart		= $LifeRP::temp::job::paycheckStart; //hour they start to get paid
			paycheckEnd			= $LifeRP::temp::job::paycheckEnd; //hour they stop getting paid
			paycheckOvertime	= $LifeRP::temp::job::paycheckOvertime; //you can set overtime paychecks if the player meets the quota (including 0) outside of the paycheck times.
			
			welfare				= $LifeRP::temp::job::welfare; //controls if you can still get welfare with this job.
			
			jobCommand			= $LifeRP::temp::job::jobCommand; //controls if you can get this job via the /getjob command.
			jobEvent			= $LifeRP::temp::job::jobEvent; //controls if you can get this job via the LifeRP_GetJob event.
		};

		if(isObject($LifeRP_job[$LifeRP::temp::job::id]))
		{
			echo("$LifeRP_job" @ $LifeRP::temp::job::id @ " sucessfully added.");
			deleteVariables("$LifeRP::temp::job::*");
			return;
		}
		else
		{
			echo("ERROR: $LifeRP_job" @ $LifeRP::temp::job::id @ " could not be added for some reason.");
			deleteVariables("$LifeRP::temp::job::*");
			return;
		}
	}
}

/////////
//Quota//
/////////

function gameConnection::LifeRP_AddQuota(%this, %amount, %job)
{
	%amount = mfloor(%amount);
	
	if(%amount == 0)
		return;
	
	if(isObject($LifeRP_job[%job]))
	{
		%jobid = $LifeRP_Player[%this.bl_id, "Job"];
		%jobid = $LifeRP_job[%jobid].id;
		
		if(!isObject($LifeRP_job[%jobid]))
		{
			%this.centerPrint("<just:right>\c6Quota \c3\"" @ %job @ "\"\c6 is incompatible with being unemployed!", 5);
			return;
		}
		
		if(%jobid $= %job)
		{
			%this.LifeRP_Quota += %amount;
			%jobLevel = mfloor($LifeRP_Player[%this.bl_id, "JobLevel", %jobid]);
			
			%hour = mfloor($LifeRP_TimeHour);
			%quota = mfloor(%this.LifeRP_Quota);
			%quotaNeeded = mfloor($LifeRP_job[%jobid].quota + %jobLevel);
			%quotaExtra = mfloor($LifeRP_job[%jobid].quotaExtra + (%jobLevel * 2));
			%quotaMessage = $LifeRP_job[%jobid].quotaMessage;
			%paycheckOvertime = $LifeRP_job[%jobid].paycheckOvertime + %jobLevel;
			%paycheckStart = $LifeRP_job[%jobid].paycheckStart;
			%paycheckEnd = $LifeRP_job[%jobid].paycheckEnd;
			
			if(%hour >= mfloor(%paycheckStart - 1) && %hour < %paycheckEnd || %paycheckOvertime > 0)
			{
				if(%quotaExtra > %quotaNeeded && %quota >= %quotaExtra && %hour >= mfloor(%paycheckStart - 1) && %hour < %paycheckEnd)
					%this.centerPrint("<just:right>\c2" @ %quota @ "\c6/\c3" @ %quotaNeeded @ "\c6 " @ %quotaMessage, 5);
				else if(%quota >= %quotaNeeded)
					%this.centerPrint("<just:right>\c3" @ %quota @ "\c6/\c3" @ %quotaNeeded @ "\c6 " @ %quotaMessage, 5);
				else
					%this.centerPrint("<just:right>\c0" @ %quota @ "\c6/\c3" @ %quotaNeeded @ "\c6 " @ %quotaMessage, 5);
			}
		}
		else
			%this.centerPrint("<just:right>\c6Quota \c3\"" @ %job @ "\"\c6 is incompatible with your job!", 5);
	}
}

//////////////
//Checks/Dos//
//////////////

function fxDtsBrick::LifeRP_checkHasJob(%this, %job, %client)
{
	if(!isObject(%client.player))
		return;
	
	%player = %client.player;
	if(!%player.getClassName() $= "Player")
		return;

	$InputTarget_["Self"] = %this;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %client;

	if(getMiniGameFromObject(%this) == getMiniGameFromObject(%client))
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%this);
	else
		$InputTarget_["MiniGame"] = 0;

	if($LifeRP_Player[%client.bl_id, "Job"] $= %job)
	{
		%this.processInputEvent(onLifeRPJobCheckPass, %client);
		return;
	}
	
	%this.processInputEvent(onLifeRPJobCheckFail, %client);
}

////////////
//Commands//
////////////

function servercmdGetJob(%client, %job)
{
	%source = "command";
	
	if(%job $= "")
	{
		%job = %client.LifeRPTemp_Job;
		%source = "event";
	}
	
	if(%job $= "")
	{
		%client.chatMessage("\c6You need to provide a job id.");
		%client.chatMessage("\c6Type \c3/jobs\c6 to get a list of usable job ids." @ %job);
		return;
	}
	
	if(%job $= "none" || %job $= "quit")
	{
		%client.LifeRP_Quota = 0;
		deleteVariables("$LifeRP_Player" @ %client.bl_id @ "_Job");
		%client.chatMessage("\c6You quit your job.");
	}
	else if(isObject($LifeRP_job[%job]))
	{
		%client.chatMessage("\c6Found job id: \c3" @ %job);
		
		if(!$LifeRP_job[%job].jobCommand && %source $= "command")
		{
			%client.chatMessage("\c6You cannot get this job with the command.");
			return;
		}
		
		if(!$LifeRP_job[%job].jobEvent && %source $= "event")
		{
			%client.chatMessage("\c6You cannot get this job with the event.");
			return;
		}
		
		%client.LifeRP_Quota = 0;
		$LifeRP_Player[%client.bl_id, "Job"] = $LifeRP_job[%job].id;
		%client.chatMessage("\c6You are now a \c3" @ $LifeRP_job[%job].name);
	}
	else
	{
		%client.chatMessage("\c6Job id not found: \c3" @ %job);
		%client.chatMessage("\c6Type \c3/jobs\c6 to get a list of usable job ids." @ %job);
		return;
	}
		
	%this.LifeRPTemp_Job = "";
	
	export("$LifeRP_Player" @ %client.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %client.BL_ID @ ".cs");
}

function servercmdJob(%client, %job)
{
	servercmdGetJob(%client, %job);
}

function serverCmdJobs(%client)
{
	%client.LifeRP_displayJobInfo("slacker");
	%client.LifeRP_displayJobInfo("writer");
	%client.LifeRP_displayJobInfo("trash");
	%client.chatMessage("\c3Press Page Up or Page Down to scroll chat.");
}

function gameConnection::LifeRP_displayJobInfo(%this, %job)
{
	if(isObject($LifeRP_job[%job]))
	{
		%quota = $LifeRP_job[%job].quota;
		
		if(%quota > 0)
			%quota = %quota SPC $LifeRP_job[%job].quotaMessage;
		else
			%quota = "None";
		
		%this.chatMessage("\c6ID: \c3" @ $LifeRP_job[%job].id @ "\c6 Name: \c3" @ $LifeRP_job[%job].name @ "\c6 Quota: \c3" @ %quota);
		
		if($LifeRP_job[%job].description1 !$= "")
			%this.chatMessage("\c6" @ $LifeRP_job[%job].description1);
		
		if($LifeRP_job[%job].description2 !$= "")
			%this.chatMessage("\c6" @ $LifeRP_job[%job].description2);
	}
}