///////////
//Startup//
///////////

function LifeRP_startItUp()
{
	if($LifeRP::Started)
	{
		echo("LifeRP was already started.");
		return;
	}
	
	LifeRP_addAllEvents();
	LifeRP_addAllMonths();
	LifeRP_addAllJobs();
	LifeRP_addAllRpItems();
	
	if(isFile("config/server/LifeRP/time.cs"))
		exec("config/server/LifeRP/time.cs");
	
	if(mfloor($LifeRP_TimeYear) <= 0)
		$LifeRP_TimeYear = 1;
	if(!isObject($LifeRP_month[mfloor($LifeRP_TimeMonth)]))
		$LifeRP_TimeMonth = 1;
	if(mfloor($LifeRP_TimeDay) > LifeRP_daysInMonth() || mfloor($LifeRP_TimeDay) <= 0)
		$LifeRP_TimeDay = 1;
	if(mfloor($LifeRP_TimeHour) >= 24 || mfloor($LifeRP_TimeHour) < 0)
		$LifeRP_TimeHour = 0;
	if(mfloor($LifeRP_TimeMinute) >= 60 || mfloor($LifeRP_TimeMinute) < 0)
		$LifeRP_TimeMinute = 0;
	
	$LifeRP::Tick = schedule($LifeRP::Pref::TickLength, 0, LifeRP_Tick);
	$LifeRP::Started = true;
}

///////
//Hud//
///////

function gameConnection::LifeRP_applyHud(%this)
{
	%blid = %this.bl_id;
	%jobid = $LifeRP_Player[%blid, "Job"];
	
	%paycheckStart = mfloor($LifeRP_job[%jobid].paycheckStart);
	%paycheckEnd = mfloor($LifeRP_job[%jobid].paycheckEnd);
	
	%hour = mfloor($LifeRP_TimeHour);
	
	//Score
	%hud = "\c2" @ $LifeRP::Pref::ScorePrefix @ mfloor($LifeRP_Player[%blid, "Score"]) @ $LifeRP::Pref::ScoreSuffix;
	
	//Time and Date
	if(isObject($LifeRP_job[%jobid]) && %hour >= %paycheckStart - 1 && %hour < %paycheckEnd && !$LifeRP_Player[%blid, "Jail"])
		%hud = %hud @ "<just:right>\c6" @ LifeRP_getDate(0) @ ", \c3" @ LifeRP_getTimeString(1);
	else
		%hud = %hud @ "<just:right>\c6" @ LifeRP_getDate(0) @ ", " @ LifeRP_getTimeString(1);
	
	//New Line
	%hud = %hud @ " <br><just:center>";
	
	//Job
	%jobName = $LifeRP_job[%jobid].name;
	%jobType = $LifeRP_job[%jobid].type;
	%jobLevel = mfloor($LifeRP_Player[%blid, "JobLevel", %jobid]);
	
	%quota = $LifeRP_job[%jobid].quota;
	%quotaExtra = $LifeRP_job[%jobid].quotaExtra;
	
	%paycheck = mfloor($LifeRP_job[%jobid].paycheck + %jobLevel);
	
	%jobRep = mfloor($LifeRP_Player[%blid, "JobRep", %jobid]);
	%repLevel = mfloor($LifeRP_job[%jobid].repLevel * (%jobLevel + 1));
	
	if(!isObject($LifeRP_job[%jobid]))
		%jobString = "\c3Unemployed";
	else if(%quotaExtra > %quota)
		%jobString = "\c3" @ %jobName SPC (%jobLevel + 1);
	else
		%jobString = "\c3" @ %jobName;
	
	if($LifeRP_Player[%blid, "Jail"])
		%paycheckString = "\c0In " @ $LifeRP::Pref::JailName;
	else if(!isObject($LifeRP_job[%jobid]))
		%paycheckString = "";
	else if(%paycheckStart == %paycheckEnd)
		%paycheckString = "\c3$" @ %paycheck SPC LifeRP_getTimeString(2, 0, %paycheckStart);
	else
		%paycheckString = "\c3$" @ %paycheck SPC LifeRP_getTimeString(2, 0, %paycheckStart) @ "-" @ LifeRP_getTimeString(2, 0, %paycheckEnd);
	
	if(%quotaExtra > %quota)
	{
		if(%jobRep >= %repLevel)
			%repString = "\c3   Rep " @ %jobRep;
		else
			%repString = "\c3   Rep " @ %jobRep;
	}
	else
		%repString = "";
	
	%hud = %hud @ %jobString @ "   " @ %paycheckString @ %repString;
	
	//Crime
	%hoursJail = mfloor($LifeRP_Player[%blid, "Jail"] / 10);
	if(%hoursJail > 0)
	{
		%hoursJail = %demerits / 10;
		%hud = %hud @ "\c0   Hours Left " @ mfloor(%hoursJail);
	}
	
	%demerits = mfloor($LifeRP_Player[%blid, "Crime"]);
	if(%demerits >= 240 || (%hoursJail > 0 && %demerits > 0))
		%hud = %hud @ "\c0   " @ $LifeRP::Pref::CrimeNamePlural SPC %demerits;
	else if(%demerits > 0)
		%hud = %hud @ "\c3   " @ $LifeRP::Pref::CrimeNamePlural SPC %demerits;
	
	//Needs
	if($LifeRP_Player[%blid, "Hunger"] >= 800)
		%hud = %hud @ "\c0   !H!";
	else if($LifeRP_Player[%blid, "Hunger"] >= 600)
		%hud = %hud @ "\c0   H";
	else if($LifeRP_Player[%blid, "Hunger"] >= 400)
		%hud = %hud @ "\c5   H";
	else if($LifeRP_Player[%blid, "Hunger"] >= 200)
		%hud = %hud @ "\c3   H";
	else if($LifeRP_Player[%blid, "Thirst"] >= 200)
		%hud = %hud @ "    ";
	
	if($LifeRP_Player[%blid, "Thirst"] >= 800)
		%hud = %hud @ "\c0 !T!";
	else if($LifeRP_Player[%blid, "Thirst"] >= 600)
		%hud = %hud @ "\c0 T";
	else if($LifeRP_Player[%blid, "Thirst"] >= 400)
		%hud = %hud @ "\c5 T";
	else if($LifeRP_Player[%blid, "Thirst"] >= 200)
		%hud = %hud @ "\c4 T";

	//Send it
	commandToClient(%this, 'bottomPrint', %hud, 0, true);
}

///////////
//Package//
///////////

if(isPackage(GameModeLifeRPMainPackage))
	deactivatePackage(GameModeLifeRPMainPackage);
package GameModeLifeRPMainPackage
{
	//////////////////
	//Player Joining//
	//////////////////
	
	function GameConnection::onClientEnterGame(%this)
	{
		Parent::onClientEnterGame(%this);
		$LifeRP_AmountClients[%this.bl_id]++;
		
		//load their save when they join
		if($LifeRP_AmountClients[%this.bl_id] <= 1)
		{
			if(isFile("config/server/LifeRP/playersaves/" @ %this.bl_id @ ".cs"))
				exec("config/server/LifeRP/playersaves/" @ %this.bl_id @ ".cs");
		}
		
		if(mfloor($LifeRP_Player[%this.bl_id, "HasJoinedBefore"]) <= 0)
		{
			$LifeRP_Player[%this.bl_id, "Score"] += mfloor($LifeRP::Pref::StartingScore);
			$LifeRP_Player[%this.bl_id, "HasJoinedBefore"] = true;
		}
		
		export("$LifeRP_Player" @ %this.bl_id @ "_*", "config/server/LifeRP/playersaves/" @ %this.bl_id @ ".cs");
	}
	
	///////////////////
	//Player Spawning//
	///////////////////
	
	function MinigameSO::pickSpawnPoint(%this, %client)
	{
		if(!$LifeRP_Player[%client.bl_id, "Jail"])
		{
			for(%a = 0; %a < getWordCount($LifeRP::Spawns); %a++)
			{
				%brick = getWord($LifeRP::Spawns, %a);
				
				if(isObject(%brick))
				{
					%spawns++;
					%spawn[%spawns] = %brick.getTransform();
					%spawn[%spawns] = VectorAdd(%spawn[%spawns], "0 0 -1.2");
				}
			}
		}
		else if($LifeRP_Player[%client.bl_id, "Jail"])
		{
			for(%a = 0; %a < getWordCount($LifeRP::PrisonSpawns); %a++)
			{
				%brick = getWord($LifeRP::PrisonSpawns, %a);
				
				if(isObject(%brick))
				{
					%spawns++;
					%spawn[%spawns] = %brick.getTransform();
					%spawn[%spawns] = VectorAdd(%spawn[%spawns], "0 0 -1.2");
				}
			}
		}
		
		if(mfloor(%spawns) > 0)
		{
			%sp = getRandom(1, %spawns);
			%pos = %spawn[%sp];
			return %pos;
		}
		else
		{
			warn("No spawns found, parenting to pickSpawnPoint.");
			parent::pickSpawnPoint(%this, %client);
		}
	}
	
	function GameConnection::spawnPlayer(%this)
	{
		Parent::spawnPlayer(%this);
		
		%player = %this.player;
		
		if(!isObject(%player))
			return;
		
		%player.tool[0] = hammerItem.getID();
		messageClient(%this, 'MsgItemPickup', '', 0, hammerItem.getID());
		%player.tool[1] = wrenchItem.getID();
		messageClient(%this, 'MsgItemPickup', '', 1, wrenchItem.getID());
		%player.tool[2] = printGun.getID();
		messageClient(%this, 'MsgItemPickup', '', 2, printGun.getID());
	}
	
	/////////////////////
	//Minigame Messages//
	/////////////////////
	
	function serverCmdcreateMiniGame(%client)
	{
		//message somehow appears already by default
		return;
	}
	
	function serverCmdleaveMiniGame(%client)
	{
		%client.chatMessage("You can't leave that mini-game.");
		return;
	}
	
	//////////////////
	//Player Leaving//
	//////////////////
	
	function gameConnection::onClientLeaveGame(%this)
	{
		export("$LifeRP_Player" @ %this.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %this.BL_ID @ ".cs");
		$LifeRP_AmountClients[%this.bl_id]--;
		
		if($LifeRP_AmountClients[%this.bl_id] <= 0)
		{
			$LifeRP_AmountClients[%this.bl_id] = 0;
			deleteVariables("$LifeRP_Player" @ %this.BL_ID @ "_*");
		}
		
		if(isObject(%this.player.tempbrick))
			%this.player.tempbrick.delete();
		
		parent::onClientLeaveGame(%this);
	}
	
	function disconnect()
	{
		//Stops the ticks just incase you're not hosting dedicated.
		if(!$Server::Dedicated)
			cancel($LifeRP::Tick);
		
		parent::disconnect();
	}
};
activatePackage(GameModeLifeRPMainPackage);