/////////////////
//Scriptobjects//
/////////////////

function LifeRP_addAllRpItems()
{
	LifeRP_addRpItemFromFile("chips");
	LifeRP_addRpItemFromFile("trash");
	LifeRP_addRpItemFromFile("wood");
	LifeRP_addRpItemFromFile("soda");
	LifeRP_addRpItemFromFile("burger");
	LifeRP_addRpItemFromFile("water");
}

function LifeRP_addRpItemFromFile(%file)
{
	if(isFile("Add-Ons/GameMode_LifeRP/rpitems/" @ %file @ ".cs"))
	{
		exec("Add-Ons/GameMode_LifeRP/rpitems/" @ %file @ ".cs");
		
		if($LifeRP::temp::rpitem::id $= "")
		{
			echo("ERROR: No ID found for" @ %file @ ".cs.");
			deleteVariables("$LifeRP::temp::rpitem::*");
			return;
		}
		
		if(isObject($LifeRP_rpItem[$LifeRP::temp::rpitem::id]))
		{
			echo("ERROR: $LifeRP_rpItem" @ $LifeRP::temp::rpitem::id @ " already exists.");
			deleteVariables("$LifeRP::temp::rpitem::*");
			return;
		}
		
		$LifeRP_rpItem[$LifeRP::temp::rpitem::id] = new scriptObject()
		{
			id					= $LifeRP::temp::rpitem::id; //can be anything, just make sure there are no spaces. example: "chips"
			name				= $LifeRP::temp::rpitem::name; //item name example: "Potato Chips"
			
			description1		= $LifeRP::temp::rpitem::description1; //description.
			description2		= $LifeRP::temp::rpitem::description2; //second line if needed.
			
			consumable			= $LifeRP::temp::rpitem::consumable; //determines if the item is a consumable and thus can be consumed by the player.
			
			addHunger			= $LifeRP::temp::rpitem::addHunger; //adds the amount of hunger to the player. food items would remove hunger by using a negative.
			addThirst			= $LifeRP::temp::rpitem::addThirst; //adds the amount of thirst to the player. drink items would remove thirst by using a negative.
			
			value				= $LifeRP::temp::rpitem::value; //how much money the item is worth.
		};

		if(isObject($LifeRP_rpItem[$LifeRP::temp::rpitem::id]))
		{
			echo("$LifeRP_rpItem" @ $LifeRP::temp::rpitem::id @ " sucessfully added.");
			deleteVariables("$LifeRP::temp::rpitem::*");
			return;
		}
		else
		{
			echo("ERROR: $LifeRP_rpItem" @ $LifeRP::temp::rpitem::id @ " could not be added for some reason.");
			deleteVariables("$LifeRP::temp::rpitem::*");
			return;
		}
	}
}

////////////
//Commands//
////////////
function servercmdBuyItem(%client, %item)
{
	if(%item $= "")
	{
		%client.chatMessage("\c6You need to provide an item id.");
		return;
	}
	
	if(isObject($LifeRP_rpItem[%item]))
	{
		%item = $LifeRP_rpItem[%item].id;
		%client.chatMessage("\c6Found item id: \c3" @ %item);
		
		if($LifeRP_Player[%client.bl_id, "Score"] >= $LifeRP_rpItem[%item].value)
		{
			%client.LifeRP_AddScore($LifeRP_rpItem[%item].value * -1, "Item Purchase");
			$LifeRP_Player[%client.bl_id, "Item", %item]++;
			%client.chatMessage("\c6You bought a \c3" @ $LifeRP_rpItem[%item].name @ ".");
		}
		else
		{
			%client.chatMessage("\c6You don't have enough " @ $LifeRP::Pref::ScoreName @ ". You need " @ $LifeRP::Pref::ScorePrefix @ $LifeRP_rpItem[%item].value @ ".");
			return;
		}
	}
	else
	{
		%client.chatMessage("\c6Item id not found: \c3" @ %item);
		return;
	}
	
	export("$LifeRP_Player" @ %client.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %client.BL_ID @ ".cs");
}

function servercmdConsume(%client, %item)
{
	if(%item $= "")
	{
		%client.chatMessage("\c6You need to provide an item id.");
		return;
	}
	
	if(isObject($LifeRP_rpItem[%item]))
	{
		%item = $LifeRP_rpItem[%item].id;
		%client.chatMessage("\c6Found item id: \c3" @ %item);
		
		if($LifeRP_Player[%client.bl_id, "Item", %item] >= 1)
		{
			if(!$LifeRP_rpItem[%item].consumable)
			{
				%client.chatMessage("\c6You can't consume \c3" @ $LifeRP_rpItem[%item].name @ ".");
				return;
			}
			
			$LifeRP_Player[%client.bl_id, "Item", %item]--;
			%client.LifeRP_AddHunger($LifeRP_rpItem[%item].addHunger);
			%client.LifeRP_AddThirst($LifeRP_rpItem[%item].addThirst);
			%client.chatMessage("\c6You consumed a \c3" @ $LifeRP_rpItem[%item].name @ ".");
		}
		else
		{
			%client.chatMessage("\c6You don't have a " @ $LifeRP_rpItem[%item].name @ ".");
			return;
		}
	}
	else
	{
		%client.chatMessage("\c6Item id not found: \c3" @ %item);
		return;
	}
	
	export("$LifeRP_Player" @ %client.BL_ID @ "_*", "config/server/LifeRP/playersaves/" @ %client.BL_ID @ ".cs");
}

function servercmdEat(%client, %item)
{
	servercmdConsume(%client, %item);
}

function servercmdDrink(%client, %item)
{
	servercmdConsume(%client, %item);
}

function serverCmdInventory(%client)
{
	if($LifeRP_Player[%client.bl_id, "Item", "chips"] > 0)
		%client.chatMessage("\c3" @ $LifeRP_rpItem["chips"].name @ "\c6: " @ $LifeRP_Player[%client.bl_id, "Item", "chips"]);
	if($LifeRP_Player[%client.bl_id, "Item", "trash"] > 0)
		%client.chatMessage("\c3" @ $LifeRP_rpItem["trash"].name @ "\c6: " @ $LifeRP_Player[%client.bl_id, "Item", "trash"]);
	if($LifeRP_Player[%client.bl_id, "Item", "wood"] > 0)
		%client.chatMessage("\c3" @ $LifeRP_rpItem["wood"].name @ "\c6: " @ $LifeRP_Player[%client.bl_id, "Item", "wood"]);
	if($LifeRP_Player[%client.bl_id, "Item", "soda"] > 0)
		%client.chatMessage("\c3" @ $LifeRP_rpItem["soda"].name @ "\c6: " @ $LifeRP_Player[%client.bl_id, "Item", "soda"]);
	if($LifeRP_Player[%client.bl_id, "Item", "burger"] > 0)
		%client.chatMessage("\c3" @ $LifeRP_rpItem["burger"].name @ "\c6: " @ $LifeRP_Player[%client.bl_id, "Item", "burger"]);
	if($LifeRP_Player[%client.bl_id, "Item", "water"] > 0)
		%client.chatMessage("\c3" @ $LifeRP_rpItem["water"].name @ "\c6: " @ $LifeRP_Player[%client.bl_id, "Item", "water"]);
	%client.chatMessage("\c3Press Page Up or Page Down to scroll chat.");
}